/*===============================================
 * Pour avoir une animation d'image a l'ecran
 * (c) Disk91 /TeKnO-BeDoUiNs/ 1998
 *===============================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 static BITMAP  * img[10];
 static RGB     * pali[10];
        RGB       pal_anim1[10][256];
 static int       imgcour;


 prepare_anim1()
 {
    int i,j;
    pali[0] = (RGB *)datfile[VNF0_PAL].dat;
    pali[1] = (RGB *)datfile[VNF1_PAL].dat;
    pali[2] = (RGB *)datfile[VNF2_PAL].dat;
    pali[3] = (RGB *)datfile[VNF3_PAL].dat;
    pali[4] = (RGB *)datfile[VNF4_PAL].dat;
    pali[5] = (RGB *)datfile[VNF5_PAL].dat;
    pali[6] = (RGB *)datfile[VNF6_PAL].dat;
    pali[7] = (RGB *)datfile[VNF7_PAL].dat;
    pali[8] = (RGB *)datfile[VNF8_PAL].dat;
    pali[9] = (RGB *)datfile[VNF9_PAL].dat;

    for ( i = 0 ; i < 10 ; i++ )
       for ( j = 0 ; j < 32 ; j++ )
          pal_anim1[i][j]=pali[i][j];

    img[0] = datfile[VNF0_PCX].dat;
    img[1] = datfile[VNF1_PCX].dat;
    img[2] = datfile[VNF2_PCX].dat;
    img[3] = datfile[VNF3_PCX].dat;
    img[4] = datfile[VNF4_PCX].dat;
    img[5] = datfile[VNF5_PCX].dat;
    img[6] = datfile[VNF6_PCX].dat;
    img[7] = datfile[VNF7_PCX].dat;
    img[8] = datfile[VNF8_PCX].dat;
    img[9] = datfile[VNF9_PCX].dat;

    clear(dblbuff);
 }

 do_anim1(int pass, int transition)
 {
    int i,j;
    int * dst;
    int * src;


    imgcour = ( pass >> 2 ) % 10;

    if ( transition && pass < 40 )
    {
      for ( i = 0 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i]);
         src  = (int *) (img[imgcour]->line[i])+ 40 -pass;
         for ( j = 0 ; j < pass*4 ; j++,dst++,src++ )
            *dst=*src;
     }
      for ( i = 1 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i])+158;
         src  = (int *) (img[imgcour]->line[i])+ 120 +pass;
         for ( j = 0 ; j < pass*4 ; j++,dst--,src-- )
            *dst=*src;
      }
    }
    else
       blit(img[imgcour],dblbuff,0,0,0,0,640,480);


}

finalise_anim1()
{
    set_palette_range(pal_anim1[imgcour],0,31,0);
}

stop_anim1()
{
   return(1);
}
