/*===============================================
 * Pour avoir une animation d'image a l'ecran
 * (c) Disk91 /TeKnO-BeDoUiNs/ 1998
 *===============================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 static BITMAP  * img;
 static RGB     * pali;
        RGB       pal_anim4[256];
 static int       imgcour;


 prepare_anim4()
 {
    int i,j;
    pali = (RGB *)datfile[IMG2_PAL].dat;

    for ( j = 0 ; j < 32 ; j++ )
       pal_anim4[j]=pali[j];

    img = datfile[IMG2_PCX].dat;

    clear(dblbuff);
 }

 do_anim4(int pass, int transition)
 {
    int i,j;
    int * dst;
    int * src;


    if ( transition && pass < 40 )
    {
      clear(dblbuff);
      for ( i = 0 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i]);
         src  = (int *) (img->line[i])+ 40 -pass;
         for ( j = 0 ; j < pass*4 ; j++,dst++,src++ )
            *dst=*src;
      }
      for ( i = 1 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i])+158;
         src  = (int *) (img->line[i])+ 120 +pass;
         for ( j = 0 ; j < pass*4 ; j++,dst--,src-- )
            *dst=*src;
      }
    }
    else
       blit(img,dblbuff,0,0,0,0,640,480);


}

finalise_anim4()
{
    set_palette_range(pal_anim4,0,31,0);
}


finalise_anim4b()
{
    set_palette_range(pal_anim4,1,31,0);
}



stop_anim4()
{
   return(1);
}
