/*===============================================
 * Pour avoir une animation d'image a l'ecran
 * (c) Disk91 /TeKnO-BeDoUiNs/ 1998
 *===============================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 static BITMAP  * img[10];
 static RGB     * pali[10];
        RGB       pal_anim5[10][256];
 static int       imgcour;


 prepare_anim5()
 {
    int i,j,x,y;

    pali[0] = (RGB *)datfile[ZFIN0_PAL].dat;
    pali[1] = (RGB *)datfile[ZFIN1_PAL].dat;
    pali[2] = (RGB *)datfile[ZFIN2_PAL].dat;
    pali[3] = (RGB *)datfile[ZFIN3_PAL].dat;
    pali[4] = (RGB *)datfile[ZFIN4_PAL].dat;
    pali[5] = (RGB *)datfile[ZFIN5_PAL].dat;
    pali[6] = (RGB *)datfile[ZFIN6_PAL].dat;
    pali[7] = (RGB *)datfile[ZFIN7_PAL].dat;
    pali[8] = (RGB *)datfile[ZFIN8_PAL].dat;
    pali[9] = (RGB *)datfile[ZFIN9_PAL].dat;

    for ( i = 0 ; i < 10 ; i++ )
       for ( j = 0 ; j < 32 ; j++ )
          pal_anim5[i][j+130]=(RGB) pali[i][j];

    img[0] = datfile[ZFIN0_PCX].dat;
    img[1] = datfile[ZFIN1_PCX].dat;
    img[2] = datfile[ZFIN2_PCX].dat;
    img[3] = datfile[ZFIN3_PCX].dat;
    img[4] = datfile[ZFIN4_PCX].dat;
    img[5] = datfile[ZFIN5_PCX].dat;
    img[6] = datfile[ZFIN6_PCX].dat;
    img[7] = datfile[ZFIN7_PCX].dat;
    img[8] = datfile[ZFIN8_PCX].dat;
    img[9] = datfile[ZFIN9_PCX].dat;

    for ( i = 0 ; i < 10 ; i++ )
       for ( y = 0 ; y < img[i]->h ; y++ )
          for ( x = 0 ; x < img[i]->w ; x++ )
             img[i]->line[y][x] += 130;


    clear(dblbuff);
 }

 do_anim5(int pass, int transition)
 {
    int i,j;
    int * dst;
    int * src;


    imgcour = ( pass >> 2 ) % 10;

    if ( transition && pass < 40 )
    {
      clear(dblbuff);
      for ( i = 0 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i]);
         src  = (int *) (img[imgcour]->line[i])+ 40 -pass;
         for ( j = 0 ; j < pass*4 ; j++,dst++,src++ )
            *dst=*src;
     }
      for ( i = 1 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i])+158;
         src  = (int *) (img[imgcour]->line[i])+ 120 +pass;
         for ( j = 0 ; j < pass*4 ; j++,dst--,src-- )
            *dst=*src;
      }
    }
    else
       blit(img[imgcour],dblbuff,0,0,0,0,640,480);
}

finalise_anim5()
{
    set_palette_range(pal_anim5[imgcour],130,163,0);
}


stop_anim5()
{
   return(1);
}
