/*==================================
 * Affiche l'image Return To The Src
 *==================================
 */

#include <allegro.h>
#include "rtsdat.h"

 static RGB      * pal;
 static RGB        palbase[256];
 static BITMAP   * bmp;
 static BITMAP   * bmp1[3];

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 Calc_Rts()
 {
   int x,y;
   bmp = ( BITMAP * )datfile[RET2SRC_PCX].dat;

   for ( y = 0 ; y < 480 ; y++)
      for ( x = 0 ; x < 640 ; x++)
         if ( bmp->line[y][x] == 252 ) bmp->line[y][x] = 0;
}


 prepare_rts()
 {
    int i;
    pal = (RGB *)datfile[RET2SRC_PAL].dat;
    for ( i = 0 ; i < 256 ; i++ )
       palbase[i] = pal[i];
 }

 do_rts(int iteration)
 {
    iteration &= 63;
    if ( iteration < 16 )
       fade_interpolate(black_palette,pal,palbase,iteration << 2,252,255);
    else
        if ( iteration < 32 )
          fade_interpolate(black_palette,pal,palbase,64,252,255);
       else
        if ( iteration < 48 )
           fade_interpolate(pal,black_palette,palbase,(iteration-32) << 2,252,255);
        else
           fade_interpolate(pal,black_palette,palbase,64,252,255);

    set_pallete_range(palbase,252,255,0);
    masked_blit(bmp,dblbuff,0,0,0,0,640,480);
 }

 stop_rts()
 {
    return(0);
 }


 /*=================================
  * pour un autre graph du meme style que rts
  *=================================
  */

 Calc_123()
 {
   int x,y,i;
   bmp1[0] = ( BITMAP * )datfile[REB1_PCX].dat;
   bmp1[1] = ( BITMAP * )datfile[REB2_PCX].dat;
   bmp1[2] = ( BITMAP * )datfile[REB3_PCX].dat;

   for ( i = 0 ; i < 3 ; i ++)
      for ( y = 0 ; y < bmp1[i]->h ; y++)
         for ( x = 0 ; x < bmp1[i]->w ; x++)
            if ( bmp1[i]->line[y][x] == 255 ) bmp1[i]->line[y][x] = 0;
}


 do_123(int gfx)
 {
   RGB white = { 63, 63, 63, 0 };

   set_color(254,&white);

   if ( gfx == 0 )
     masked_blit(bmp1[0],dblbuff,0,0,0,0,bmp1[0]->w,bmp1[0]->h);
   if ( gfx == 1 )
     masked_blit(bmp1[1],dblbuff,0,0,440,0,bmp1[1]->w,bmp1[1]->h);
   if ( gfx == 2 )
     masked_blit(bmp1[2],dblbuff,0,0,440,250,bmp1[2]->w,bmp1[2]->h);
 }

 stop_123()
 {
    RGB white = { 63,63,63,0 };
    int i;

    for (i = 0 ; i < 256 ; i++)
       set_color(i,&white);
    fade_out( 4 );
 }






