/*========================================
 * wobber ou un truc du style
 * (c) Disk91 / TeKnO-BeDoUiNs / 1998
 * pour la rts
 *========================================
 */


 #include <allegro.h>
 #include "rtsdat.h"


 static BITMAP   * bmp;
 static RGB      * pal;

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 /*----------------------------------
  * Primitives
  *----------------------------------
  */

static dr_wobber(int y, int couldep)
{
   int i,j;
   int * ofd = (int *) bmp->line[y];
   int c;
   int vinc = 1 + (1 << 8) + (1 << 16) +(1 << 24);

   c = couldep + (couldep << 8) + (couldep << 16) + (couldep << 24);
   for ( i = 0 ; i < 8 ; i++ )
   {
      for ( j = 0 ; j < 160 ; j++,ofd++ )
        *ofd = c;
        c += vinc;
   }

   for ( i = 0 ; i < 8  ; i++ )
   {
      c -= vinc;
      for ( j = 0 ; j < 160 ; j++,ofd++ )
         *ofd = c;
   }
}


 /*----------------------------------
  * PRINCIPALES
  *----------------------------------
  */

 fix_wobber()
 {
    RGB white = {63,63,63,0};
    pal = ( RGB * ) datfile[WOBBER_PAL].dat;

    set_palette_range(pal,1,40,0);
    set_color(41,&white);
 }


 prepare_wobber()
 {
    bmp = create_bitmap(640,480);
 }

 do_wobber(int iter)
 {
    int i;
    int it = iter;

    iter = (iter & 127) << 1;

    clear(bmp);
    for ( i = 0 ; i < 5 ; i++ )
      dr_wobber(fixtoi( 100*fsin( ((iter+10*i) & 255 ) << 16 ))+240, 1+((4-i) << 3));

    if ( it < 108 )
    {
       hline(dblbuff,0,248+it,640,41);
       hline(dblbuff,0,248-it,640,41);
       blit(bmp,dblbuff,0,249-it,0,249-it,640,(it << 1)-1);
    }
    else
    {
       hline(dblbuff,0,356,640,41);
       hline(dblbuff,0,140,640,41);
       blit(bmp,dblbuff,0,141,0,141,640,215);
    }

 }

 stop_wobber()
 {
   destroy_bitmap(bmp);
 }



