/*===============================================
 * Pour avoir une animation d'image a l'ecran
 * (c) Disk91 /TeKnO-BeDoUiNs/ 1998
 *===============================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 static BITMAP  * img[9];
 static RGB     * pali[9];
        RGB       pal_anim2[9][256];
 static int       imgcour;


 prepare_anim2()
 {
    int i,j;
    pali[0] = (RGB *)datfile[BUMP1_PAL].dat;
    pali[1] = (RGB *)datfile[BUMP2_PAL].dat;
    pali[2] = (RGB *)datfile[BUMP3_PAL].dat;
    pali[3] = (RGB *)datfile[BUMP4_PAL].dat;
    pali[4] = (RGB *)datfile[BUMP5_PAL].dat;
    pali[5] = (RGB *)datfile[BUMP6_PAL].dat;
    pali[6] = (RGB *)datfile[BUMP7_PAL].dat;
    pali[7] = (RGB *)datfile[BUMP8_PAL].dat;
    pali[8] = (RGB *)datfile[BUMP9_PAL].dat;

    for ( i = 0 ; i < 9 ; i++ )
       for ( j = 0 ; j < 32 ; j++ )
          pal_anim2[i][j]=pali[i][j];

    img[0] = datfile[BUMP1_PCX].dat;
    img[1] = datfile[BUMP2_PCX].dat;
    img[2] = datfile[BUMP3_PCX].dat;
    img[3] = datfile[BUMP4_PCX].dat;
    img[4] = datfile[BUMP5_PCX].dat;
    img[5] = datfile[BUMP6_PCX].dat;
    img[6] = datfile[BUMP7_PCX].dat;
    img[7] = datfile[BUMP8_PCX].dat;
    img[8] = datfile[BUMP9_PCX].dat;

    clear(dblbuff);
 }

 do_anim2(int pass, int transition)
 {
    int i,j;
    int * dst;
    int * src;


    imgcour = ( pass >> 2 ) % 9;

    if ( transition && pass < 40 )
    {
      clear(dblbuff);
      for ( i = 0 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i]);
         src  = (int *) (img[imgcour]->line[i])+ 40 -pass;
         for ( j = 0 ; j < pass*4 ; j++,dst++,src++ )
            *dst=*src;
     }
      for ( i = 1 ; i < 480 ; i+=2 )
      {
         dst  = (int *) (dblbuff->line[i])+158;
         src  = (int *) (img[imgcour]->line[i])+ 120 +pass;
         for ( j = 0 ; j < pass*4 ; j++,dst--,src-- )
            *dst=*src;
      }
    }
    else
       blit(img[imgcour],dblbuff,0,0,0,0,640,480);


}

finalise_anim2()
{
    set_palette_range(pal_anim2[imgcour],0,31,0);
}

stop_anim2()
{
   return(1);
}
