/*=====================================
 * AFFICHAGE DES GREETS
 * (c) Disk91 /TeKnO-BeDoUiNs/1998 rts
 *=====================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 static FONT     * grfont[4];

 extern BITMAP   * dblbuff;
 extern DATAFILE * datfile;

 static char       greets[4][10][50] ={ { "A TeKnO-BeDoUiNs Production",
                                          "Code : Disk91 /TeKnO-BeDoUiNs/",
                                          "Code : BoBo [The King] /TkB/",
                                          "Graph : Biro /Wild-Spirit/",
                                          "Mental support : Puce",
                                          "Zic : Mp3  Fire -Scooter-"
                                         },
                                         { "Greets goes to : TkB members",
                                           "BoBo [The King]",
                                           "Cna",
                                           "DiDoU",
                                           "Elmer Beacon",
                                           "PeDrO DeL CaMpO",
                                           "Terrax",
                                           "Bouh ",
                                           "Viper Arakyde",
                                         },
                                         { "Greets goes to : ",
                                           "Biro [Special Thanks]",
                                           "LightShow & [EcLiPsE]/",
                                           "Fox - Alkama",
                                           "Grems",
                                           "I.S.I.M.A.",
                                           "Kheops",
                                           "Spawn - S.H.K.",
                                           "Somy",
                                           "Tango"
                                         },
                                         { "Here is a nice cube",
                                           "Rotozoom mapping",
                                           "Bump mapping"
                                         }

                                       };

 static int        posx[4][10] = { {   320, 320, 320, 320, 320, 320 },
                                   {   320, 320, 320, 320, 320, 320, 320, 320, 320 },
                                   {   320, 320, 320, 320, 320, 320, 320, 320, 320,320 },
                                   {   320, 320, 320, 320, 320, 320, 320, 320, 320,320 }
                                 };
 static int        posy[4][10] = { {   20, 420, 420, 420, 420, 420 },
                                   {   20, 420, 420, 420, 420, 420, 420, 420, 420 },
                                   {   20, 420, 420, 420, 420, 420, 420, 420, 420, 420 },
                                   {   20, 420, 420, 420, 420, 420, 420, 420, 420, 420 }
                                 };



/*------------------
 * PRIMITIVES
 *------------------
 */

static dr_greets(int iteration,int x, int y, char * string,int c)
{
  text_mode(-1);
  textout_centre( dblbuff, grfont[iteration & 3], string, x, y, c );
}


/*---------------------
 * PRINCIPALES
 *---------------------
 */

fix_greets(int c)
{
  RGB white = { 63,33,0,0 };
  set_color(c,&white);
}


prepare_greets(int c)
{
  RGB white = { 63,33,0,0 };
  set_color(c,&white);

  grfont[0] =  (FONT *) datfile[GREET1_FNT].dat;
  grfont[1] =  (FONT *) datfile[GREET2_FNT].dat;
  grfont[2] =  (FONT *) datfile[GREET3_FNT].dat;
  grfont[3] =  (FONT *) datfile[GREET4_FNT].dat;
}


do_greets(int iteration,int txt,int c,int div)
{
  int it;

  it = iteration / div;
  if (it > 9) it = 9;
  dr_greets(iteration >> 2,posx[txt][0],posy[txt][0],greets[txt][0],c);

  if ( it > 0 )
     dr_greets(iteration >> 2,posx[txt][it],posy[txt][it],greets[txt][it],c);
}

stop_greets()
{
  return(0);
}









