/*=====================================================================
 * Intro.c : demarrage de la demo
 *           affiche du texte dans le style precalcul a la con de
 *           debut de demo ou jeux
 *=====================================================================
 */

 #include <allegro.h>
 #include <libamp.h>
 #include "rtsdat.h"

 static BITMAP   * bmp;
 extern DATAFILE * datfile;
 static int        state = 1;

 prepare_intro()
 {
    char     chaine1[] = " Precalculating Lights()";
    char     chaine2[] = " Making n'object a la con()";
    char     chaine3[] = " Preparing next string()";
    char     chaine4[] = " Makes people waiting()";
    char     chaine5[] = " Do you like waiting (?!?)";
    char     chaine6[] = " Nice sun isn't it(?)";
    char     chaine7[] = " Synching with moon() ";
    char     chaine8[] = " Waiting for Intel Space Engineer()";
    char     chaine9[] = " Have you ever visit a Turkish jail(?)";
    char     chaine10[] =" Waiting music sync()";
    int      i,j;
    FONT *   myintrofont;


    /*--- la palette ---*/
    set_palette(black_palette);

    /*--- le bitmap ---*/
    dsk_mp3_getsema();
    bmp = create_bitmap(640,480);
    dsk_mp3_givesema();
    clear(bmp);

    myintrofont = datfile[COMICS20_PCX].dat;

    /*--- le texte dedans ---*/
    j=1;
    textout(bmp,myintrofont,chaine1,10,5,j);
    j++;
    for ( i = 0 ; i < 8 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine1) + 10*i, 5,j);

    textout(bmp,myintrofont,chaine2,10,45,j);
    j++;
    for ( i = 0 ; i < 6 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine2) + 10*i, 45,j);

    textout(bmp,myintrofont,chaine3,10,85,j);
    j++;
    for ( i = 0 ; i < 11 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine3) + 10*i, 85,j);

    textout(bmp,myintrofont,chaine4,10,125,j);
    j++;
    for ( i = 0 ; i < 4 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine4) + 10*i, 125,j);

    textout(bmp,myintrofont,chaine5,10,165,j);
    j++;
    for ( i = 0 ; i < 6 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine5) + 10*i, 165,j);

    textout(bmp,myintrofont,chaine6,10,205,j);
    j++;
    for ( i = 0 ; i < 8 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine6) + 10*i, 205,j);

    textout(bmp,myintrofont,chaine7,10,245,j);
    j++;
    for ( i = 0 ; i < 7 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine7) + 10*i, 245,j);

    textout(bmp,myintrofont,chaine8,10,285,j);
    j++;
    for ( i = 0 ; i < 6 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine8) + 10*i, 285,j);

    textout(bmp,myintrofont,chaine9,10,325,j);
    j++;
    for ( i = 0 ; i < 8 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine9) + 10*i, 325,j);

    textout(bmp,myintrofont,chaine10,10,365,j);
    j++;
    for ( i = 0 ; i < 7 ; i++,j++ )
       textout(bmp,myintrofont,".", 10 + text_length(myintrofont,chaine10) + 10*i, 365,j);

    blit(bmp,screen,0,0,0,0,640,480);

 }

 do_intro(int pass)
 {
    int c_color;        /* couleur courante */
    RGB color[4] = { {  8, 8, 8,0 },
                     { 20,20,20,0 },
                     { 35,35,35,0 },
                     { 63,63,63,0 } };

    if ( pass < 324 )
    {
       c_color = (pass >> 2) + 1;
       set_color(c_color, &color[ pass & 3 ]);
    }
    else
    {
      if (state < 4)
      {
         set_color(74,&color[0]);
         state++;
      }
      else
      {
         set_color(74,&color[3]);
         (state >= 6) ? state = 0 : state++ ;
      }
    }
 }

 stop_intro()
 {
    RGB color = { 63,63,63 };

    destroy_bitmap(bmp);
    set_color(0,&color);
    set_color(74,&color);
    fade_out_range( 4, 0, 82 );
    clear(screen);

 }


